﻿' This class contains the several possible commands you can use.
Public Class Command

    Public Delegate Sub doAction(ByVal waarde As Integer)

    Private _name As String
    Private _action As doAction
    Private _parameterCount As Integer
    Private _description As String
    Private _numberOfParameters As Integer
    Private _parameters() As String
    Private _minValue As Integer = -1
    Private _maxValue As Integer = -1


    Public Property minvalue() As Integer
        Get
            Return _minValue
        End Get
        Set(ByVal value As Integer)
            _minValue = value
        End Set
    End Property

    Public Property maxValue() As Integer
        Get
            Return _maxValue
        End Get
        Set(ByVal value As Integer)
            _maxValue = value
        End Set
    End Property


    Public Property name() As String
        Get
            Return _name
        End Get
        Set(ByVal value As String)
            _name = value
        End Set
    End Property

    Public Property action() As doAction
        Get
            Return _action
        End Get
        Set(ByVal value As doAction)
            _action = value
        End Set
    End Property
    Public Property description() As String
        Get
            Return _description
        End Get
        Set(ByVal value As String)
            _description = value
        End Set
    End Property


    ' Constructor
    Public Sub New(ByVal name As String, ByVal action As doAction, ByVal parameterCount As Integer)
        _name = name.Trim().ToUpper()
        _action = action
        _parameterCount = parameterCount
    End Sub

    ' Constructor 
    Public Sub New(ByVal name As String, ByVal action As doAction, ByVal parameterCount As Integer, ByVal minValue As Integer, ByVal maxValue As Integer)
        _name = name.Trim().ToUpper()
        _action = action
        _parameterCount = parameterCount
        _minValue = minValue
        _maxValue = maxValue
    End Sub



    Public Function execute(ByVal paramString() As String)
        Dim sizeOfArray As Integer
        sizeOfArray = UBound(paramString)

        If sizeOfArray = _parameterCount Then
            Select Case sizeOfArray
                Case 0
                    ' No parameters. Invoke function no value (just pass False)
                    action.Invoke(False)
                    Return Nothing

                Case 1
                    ' A parameter was given. Test the parameter first!
                    Dim res As Integer = testParameter(paramString(1))
                    If res > -1 Then
                        action.Invoke(res)
                        Return Nothing
                    Else
                        Return "The specified parameter is not in the desired range (" & _minValue & "-" & _maxValue & ")"
                    End If


                Case Else
                    Return "This number of parameters is currently not supported!"
            End Select
        Else
            Return "Incorrect number of parameters. Expected: " & _parameterCount
        End If

        Return "Unexpected result"
    End Function


    ' the testParameter function will validate a parameter.
    Private Function testParameter(ByVal parameter As String) As Integer
        Dim res As Integer
        If Integer.TryParse(parameter, res) Then
            If res >= _minValue And res <= _maxValue Then
                Return res
            Else
                Return -1
            End If
        Else
            Return -1
        End If

    End Function
End Class
